Index: /trunk/packages/vizservers/vtkvis/RpVtkRenderer.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpVtkRenderer.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpVtkRenderer.cpp	(revision 2423)
@@ -24,8 +24,8 @@
 #include <vtkCharArray.h>
 #include <vtkAxisActor2D.h>
+#include <vtkCubeAxesActor.h>
 #ifdef USE_CUSTOM_AXES
-#include <vtkRpCubeAxesActor2D.h>
+#include "vtkRpCubeAxesActor2D.h"
 #else
-#include <vtkCubeAxesActor.h>
 #include <vtkCubeAxesActor2D.h>
 #endif
@@ -53,6 +53,8 @@
 Renderer::Renderer() :
     _needsRedraw(true),
-    _windowWidth(320),
-    _windowHeight(320),
+    _windowWidth(500),
+    _windowHeight(500),
+    _imgCameraPlane(PLANE_XY),
+    _imgCameraOffset(0),
     _cameraZoomRatio(1),
     _useCumulativeRange(true),
@@ -657,4 +659,13 @@
 }
 
+void Renderer::getDataSetNames(std::vector<std::string>& names)
+{
+    names.clear();
+    for (DataSetHashmap::iterator itr = _dataSets.begin();
+         itr != _dataSets.end(); ++itr) {
+        names.push_back(itr->second->getName());
+    }
+}
+
 /**
  * \brief Find the DataSet for the given DataSetId key
@@ -850,4 +861,5 @@
     _cubeAxesActor2D->GetXAxisActor2D()->AdjustLabelsOn();
     _cubeAxesActor2D->GetYAxisActor2D()->AdjustLabelsOn();
+    _cubeAxesActor2D->GetZAxisActor2D()->AdjustLabelsOn();
 
 #ifdef USE_CUSTOM_AXES
@@ -869,4 +881,12 @@
     _cubeAxesActor2D->GetYAxisActor2D()->GetLabelTextProperty()->ItalicOff();
     _cubeAxesActor2D->GetYAxisActor2D()->GetLabelTextProperty()->ShadowOff();
+
+    //_cubeAxesActor2D->GetZAxisActor2D()->SizeFontRelativeToAxisOn();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetTitleTextProperty()->BoldOn();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetTitleTextProperty()->ItalicOff();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetTitleTextProperty()->ShadowOn();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetLabelTextProperty()->BoldOff();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetLabelTextProperty()->ItalicOff();
+    _cubeAxesActor2D->GetZAxisActor2D()->GetLabelTextProperty()->ShadowOff();
 #else
     _cubeAxesActor2D->GetAxisTitleTextProperty()->BoldOn();
@@ -1459,5 +1479,5 @@
  * \brief Create a new Contour2D and associate it with the named DataSet
  */
-void Renderer::addContour2D(const DataSetId& id, int numContours)
+bool Renderer::addContour2D(const DataSetId& id, int numContours)
 {
     DataSetHashmap::iterator itr;
@@ -1472,5 +1492,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -1485,6 +1505,5 @@
 
         Contour2D *contour = new Contour2D(numContours);
-        _contour2Ds[dsID] = contour;
-
+ 
         contour->setDataSet(ds,
                             _useCumulativeRange, 
@@ -1493,9 +1512,17 @@
                             _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(contour->getProp());
+        if (contour->getProp() == NULL) {
+            delete contour;
+            return false;
+        } else {
+            _renderer->AddViewProp(contour->getProp());
+        }
+
+        _contour2Ds[dsID] = contour;
     } while (doAll && ++itr != _dataSets.end());
 
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -1503,5 +1530,5 @@
  * \brief Create a new Contour2D and associate it with the named DataSet
  */
-void Renderer::addContour2D(const DataSetId& id, const std::vector<double>& contours)
+bool Renderer::addContour2D(const DataSetId& id, const std::vector<double>& contours)
 {
     DataSetHashmap::iterator itr;
@@ -1516,5 +1543,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -1529,5 +1556,4 @@
 
         Contour2D *contour = new Contour2D(contours);
-        _contour2Ds[dsID] = contour;
 
         contour->setDataSet(ds,
@@ -1537,9 +1563,17 @@
                             _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(contour->getProp());
+        if (contour->getProp() == NULL) {
+            delete contour;
+            return false;
+        } else {
+            _renderer->AddViewProp(contour->getProp());
+        }
+
+        _contour2Ds[dsID] = contour;
     } while (doAll && ++itr != _dataSets.end());
 
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -1894,5 +1928,5 @@
  * \brief Create a new Contour3D and associate it with the named DataSet
  */
-void Renderer::addContour3D(const DataSetId& id, int numContours)
+bool Renderer::addContour3D(const DataSetId& id, int numContours)
 {
     DataSetHashmap::iterator itr;
@@ -1907,5 +1941,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -1920,5 +1954,4 @@
 
         Contour3D *contour = new Contour3D(numContours);
-        _contour3Ds[dsID] = contour;
 
         contour->setDataSet(ds,
@@ -1928,5 +1961,12 @@
                             _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(contour->getProp());
+        if (contour->getProp() == NULL) {
+            delete contour;
+            return false;
+        } else {
+            _renderer->AddViewProp(contour->getProp());
+        }
+
+        _contour3Ds[dsID] = contour;
     } while (doAll && ++itr != _dataSets.end());
 
@@ -1935,4 +1975,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -1940,5 +1981,5 @@
  * \brief Create a new Contour3D and associate it with the named DataSet
  */
-void Renderer::addContour3D(const DataSetId& id,const std::vector<double>& contours)
+bool Renderer::addContour3D(const DataSetId& id,const std::vector<double>& contours)
 {
     DataSetHashmap::iterator itr;
@@ -1953,5 +1994,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -1966,5 +2007,4 @@
 
         Contour3D *contour = new Contour3D(contours);
-        _contour3Ds[dsID] = contour;
 
         contour->setDataSet(ds,
@@ -1974,5 +2014,12 @@
                             _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(contour->getProp());
+        if (contour->getProp() == NULL) {
+            delete contour;
+            return false;
+        } else {
+            _renderer->AddViewProp(contour->getProp());
+        }
+
+        _contour3Ds[dsID] = contour;
     } while (doAll && ++itr != _dataSets.end());
 
@@ -1981,4 +2028,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -2453,5 +2501,5 @@
  * \brief Create a new Glyphs and associate it with the named DataSet
  */
-void Renderer::addGlyphs(const DataSetId& id, Glyphs::GlyphShape shape)
+bool Renderer::addGlyphs(const DataSetId& id, Glyphs::GlyphShape shape)
 {
     DataSetHashmap::iterator itr;
@@ -2466,5 +2514,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -2479,5 +2527,4 @@
 
         Glyphs *glyphs = new Glyphs(shape);
-        _glyphs[dsID] = glyphs;
 
         glyphs->setDataSet(ds,
@@ -2487,5 +2534,12 @@
                            _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(glyphs->getProp());
+        if (glyphs->getProp() == NULL) {
+            delete glyphs;
+            return false;
+        } else {
+            _renderer->AddViewProp(glyphs->getProp());
+        }
+
+        _glyphs[dsID] = glyphs;
     } while (doAll && ++itr != _dataSets.end());
 
@@ -2495,4 +2549,5 @@
 
     _needsRedraw = true;
+    return true;
 }
 
@@ -3022,5 +3077,5 @@
  * \brief Create a new HeightMap and associate it with the named DataSet
  */
-void Renderer::addHeightMap(const DataSetId& id, int numContours)
+bool Renderer::addHeightMap(const DataSetId& id, int numContours, double heightScale)
 {
     DataSetHashmap::iterator itr;
@@ -3035,5 +3090,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -3047,6 +3102,5 @@
         }
 
-        HeightMap *hmap = new HeightMap(numContours);
-        _heightMaps[dsID] = hmap;
+        HeightMap *hmap = new HeightMap(numContours, heightScale);
 
         hmap->setDataSet(ds,
@@ -3056,5 +3110,12 @@
                          _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(hmap->getProp());
+        if (hmap->getProp() == NULL) {
+            delete hmap;
+            return false;
+        } else {
+            _renderer->AddViewProp(hmap->getProp());
+        }
+
+        _heightMaps[dsID] = hmap;
     } while (doAll && ++itr != _dataSets.end());
 
@@ -3064,4 +3125,5 @@
 
     _needsRedraw = true;
+    return true;
 }
 
@@ -3069,5 +3131,5 @@
  * \brief Create a new HeightMap and associate it with the named DataSet
  */
-void Renderer::addHeightMap(const DataSetId& id, const std::vector<double>& contours)
+bool Renderer::addHeightMap(const DataSetId& id, const std::vector<double>& contours, double heightScale)
 {
     DataSetHashmap::iterator itr;
@@ -3082,5 +3144,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -3094,6 +3156,5 @@
         }
 
-        HeightMap *hmap = new HeightMap(contours);
-        _heightMaps[dsID] = hmap;
+        HeightMap *hmap = new HeightMap(contours, heightScale);
 
         hmap->setDataSet(ds,
@@ -3103,5 +3164,12 @@
                          _cumulativeVectorComponentRange);
 
-        _renderer->AddViewProp(hmap->getProp());
+        if (hmap->getProp() == NULL) {
+            delete hmap;
+            return false;
+        } else {
+            _renderer->AddViewProp(hmap->getProp());
+        }
+
+        _heightMaps[dsID] = hmap;
     } while (doAll && ++itr != _dataSets.end());
 
@@ -3111,4 +3179,5 @@
 
     _needsRedraw = true;
+    return true;
 }
 
@@ -3368,5 +3437,5 @@
  * \brief Set the number of equally spaced contour isolines for the given DataSet
  */
-void Renderer::setHeightMapContours(const DataSetId& id, int numContours)
+void Renderer::setHeightMapNumContours(const DataSetId& id, int numContours)
 {
     HeightMapHashmap::iterator itr;
@@ -3386,5 +3455,5 @@
 
     do {
-        itr->second->setContours(numContours);
+        itr->second->setNumContours(numContours);
     } while (doAll && ++itr != _heightMaps.end());
 
@@ -3468,4 +3537,31 @@
     do {
         itr->second->setVisibility(state);
+    } while (doAll && ++itr != _heightMaps.end());
+
+    _needsRedraw = true;
+}
+
+/**
+ * \brief Set wireframe rendering for the specified DataSet
+ */
+void Renderer::setHeightMapWireframe(const DataSetId& id, bool state)
+{
+    HeightMapHashmap::iterator itr;
+
+    bool doAll = false;
+
+    if (id.compare("all") == 0) {
+        itr = _heightMaps.begin();
+        doAll = true;
+    } else {
+        itr = _heightMaps.find(id);
+    }
+    if (itr == _heightMaps.end()) {
+        ERROR("HeightMap not found: %s", id.c_str());
+        return;
+    }
+
+    do {
+        itr->second->setWireframe(state);
     } while (doAll && ++itr != _heightMaps.end());
 
@@ -3560,5 +3656,5 @@
  * \brief Turn on/off rendering height map contour lines for the given DataSet
  */
-void Renderer::setHeightMapContourVisibility(const DataSetId& id, bool state)
+void Renderer::setHeightMapContourLineVisibility(const DataSetId& id, bool state)
 {
     HeightMapHashmap::iterator itr;
@@ -3578,5 +3674,32 @@
 
     do {
-        itr->second->setContourVisibility(state);
+        itr->second->setContourLineVisibility(state);
+    } while (doAll && ++itr != _heightMaps.end());
+
+    _needsRedraw = true;
+}
+
+/**
+ * \brief Turn on/off rendering height map colormap surface for the given DataSet
+ */
+void Renderer::setHeightMapContourSurfaceVisibility(const DataSetId& id, bool state)
+{
+    HeightMapHashmap::iterator itr;
+
+    bool doAll = false;
+
+    if (id.compare("all") == 0) {
+        itr = _heightMaps.begin();
+        doAll = true;
+    } else {
+        itr = _heightMaps.find(id);
+    }
+    if (itr == _heightMaps.end()) {
+        ERROR("HeightMap not found: %s", id.c_str());
+        return;
+    }
+
+    do {
+        itr->second->setContourSurfaceVisibility(state);
     } while (doAll && ++itr != _heightMaps.end());
 
@@ -3670,5 +3793,5 @@
  * \brief Create a new LIC and associate it with the named DataSet
  */
-void Renderer::addLIC(const DataSetId& id)
+bool Renderer::addLIC(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -3683,5 +3806,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -3711,4 +3834,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -4103,5 +4227,5 @@
  * \brief Create a new Molecule and associate it with the named DataSet
  */
-void Renderer::addMolecule(const DataSetId& id)
+bool Renderer::addMolecule(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -4116,5 +4240,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -4140,4 +4264,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -4611,5 +4736,5 @@
  * \brief Create a new PolyData and associate it with the named DataSet
  */
-void Renderer::addPolyData(const DataSetId& id)
+bool Renderer::addPolyData(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -4624,5 +4749,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -4648,4 +4773,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -4971,7 +5097,10 @@
 
 /**
- * \brief Set wireframe rendering for the specified DataSet
- */
-void Renderer::setPolyDataWireframe(const DataSetId& id, bool state)
+ * \brief Set the point size for the specified DataSet (may be a no-op)
+ *
+ * If the OpenGL implementation/hardware does not support wide points, 
+ * this function may not have an effect.
+ */
+void Renderer::setPolyDataPointSize(const DataSetId& id, float size)
 {
     PolyDataHashmap::iterator itr;
@@ -4991,4 +5120,31 @@
 
     do {
+        itr->second->setPointSize(size);
+    } while (doAll && ++itr != _polyDatas.end());
+
+    _needsRedraw = true;
+}
+
+/**
+ * \brief Set wireframe rendering for the specified DataSet
+ */
+void Renderer::setPolyDataWireframe(const DataSetId& id, bool state)
+{
+    PolyDataHashmap::iterator itr;
+
+    bool doAll = false;
+
+    if (id.compare("all") == 0) {
+        itr = _polyDatas.begin();
+        doAll = true;
+    } else {
+        itr = _polyDatas.find(id);
+    }
+    if (itr == _polyDatas.end()) {
+        ERROR("PolyData not found: %s", id.c_str());
+        return;
+    }
+
+    do {
         itr->second->setWireframe(state);
     } while (doAll && ++itr != _polyDatas.end());
@@ -5027,5 +5183,5 @@
  * \brief Create a new PseudoColor rendering for the specified DataSet
  */
-void Renderer::addPseudoColor(const DataSetId& id)
+bool Renderer::addPseudoColor(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -5040,5 +5196,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -5065,4 +5221,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -5461,5 +5618,5 @@
  * \brief Create a new Streamlines and associate it with the named DataSet
  */
-void Renderer::addStreamlines(const DataSetId& id)
+bool Renderer::addStreamlines(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -5474,5 +5631,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -5500,4 +5657,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -6230,5 +6388,5 @@
  * \brief Create a new Volume and associate it with the named DataSet
  */
-void Renderer::addVolume(const DataSetId& id)
+bool Renderer::addVolume(const DataSetId& id)
 {
     DataSetHashmap::iterator itr;
@@ -6243,5 +6401,5 @@
     if (itr == _dataSets.end()) {
         ERROR("Unknown dataset %s", id.c_str());
-        return;
+        return false;
     }
 
@@ -6271,4 +6429,5 @@
     initCamera();
     _needsRedraw = true;
+    return true;
 }
 
@@ -6652,5 +6811,9 @@
 void Renderer::setWindowSize(int width, int height)
 {
-    setViewAngle(height);
+    if (_windowWidth == width &&
+        _windowHeight == height)
+        return;
+
+    //setViewAngle(height);
 
     // FIXME: Fix up panning on aspect change
@@ -6691,4 +6854,6 @@
     CameraMode origMode = _cameraMode;
     _cameraMode = mode;
+    resetAxes();
+
     vtkSmartPointer<vtkCamera> camera = _renderer->GetActiveCamera();
     switch (mode) {
@@ -6719,6 +6884,4 @@
         ERROR("Unkown camera mode: %d", mode);
     }
-    resetAxes();
-
     _needsRedraw = true;
 }
@@ -7173,9 +7336,10 @@
         setCameraZoomRegion(_imgWorldOrigin[0], _imgWorldOrigin[1],
                             _imgWorldDims[0], _imgWorldDims[1]);
-    } else if (_cameraMode == ORTHO) {
-        camera->Zoom(z); // Change ortho parallel scale (Dolly has no effect in ortho)
-        _renderer->ResetCameraClippingRange();
-    } else {
-        camera->Dolly(z); // Move camera forward/back
+    } else {
+        // Keep ortho and perspective modes in sync
+        // Move camera forward/back for perspective camera
+        camera->Dolly(z);
+        // Change ortho parallel scale
+        camera->SetParallelScale(camera->GetParallelScale()/z);
         _renderer->ResetCameraClippingRange();
         //computeScreenWorldCoords();
@@ -7186,4 +7350,31 @@
 
     _needsRedraw = true;
+}
+
+/**
+ * \brief Set the pan/zoom using a corner and dimensions in pixel coordinates
+ * 
+ * \param[in] x left pixel coordinate
+ * \param[in] y bottom  pixel coordinate (with y=0 at top of window)
+ * \param[in] width Width of zoom region in pixel coordinates
+ * \param[in] height Height of zoom region in pixel coordinates
+ */
+void Renderer::setCameraZoomRegionPixels(int x, int y, int width, int height)
+{
+    double wx, wy, ww, wh;
+
+    y = _windowHeight - y;
+    double pxToWorldX = _screenWorldCoords[2] / (double)_windowWidth;
+    double pxToWorldY = _screenWorldCoords[3] / (double)_windowHeight;
+
+    wx = _screenWorldCoords[0] + x * pxToWorldX;
+    wy = _screenWorldCoords[1] + y * pxToWorldY;
+    ww = abs(width) *  pxToWorldX;
+    wh = abs(height) * pxToWorldY;
+    setCameraZoomRegion(wx, wy, ww, wh);
+
+    TRACE("\npx: %d %d %d %d\nworld: %g %g %g %g",
+          x, y, width, height,
+          wx, wy, ww, wh);
 }
 
@@ -7200,7 +7391,10 @@
     double camPos[2];
 
-    int pxOffsetX = 85;
-    int pxOffsetY = 75;
-    int outerGutter = 15;
+    int pxOffsetX = (int)(0.17 * (double)_windowWidth);
+    pxOffsetX = (pxOffsetX > 100 ? 100 : pxOffsetX);
+    int pxOffsetY = (int)(0.15 * (double)_windowHeight);
+    pxOffsetY = (pxOffsetY > 75 ? 75 : pxOffsetY);
+    int outerGutter = (int)(0.03 * (double)_windowWidth);
+    outerGutter = (outerGutter > 15 ? 15 : outerGutter);
 
     int imgHeightPx = _windowHeight - pxOffsetY - outerGutter;
@@ -7238,22 +7432,78 @@
     vtkSmartPointer<vtkCamera> camera = _renderer->GetActiveCamera();
     camera->ParallelProjectionOn();
-    camera->SetPosition(camPos[0], camPos[1], 1);
-    camera->SetFocalPoint(camPos[0], camPos[1], 0);
-    camera->SetViewUp(0, 1, 0);
     camera->SetClippingRange(1, 2);
     // Half of world coordinate height of viewport (Documentation is wrong)
     camera->SetParallelScale(_windowHeight * pxToWorld / 2.0);
 
-    // bottom
-    _cameraClipPlanes[0]->SetOrigin(0, _imgWorldOrigin[1], 0);
-    // left
-    _cameraClipPlanes[1]->SetOrigin(_imgWorldOrigin[0], 0, 0);
-    // top
-    _cameraClipPlanes[2]->SetOrigin(0, _imgWorldOrigin[1] + _imgWorldDims[1], 0);
-    // right
-    _cameraClipPlanes[3]->SetOrigin(_imgWorldOrigin[0] + _imgWorldDims[0], 0, 0);
-
-    _cubeAxesActor2D->SetBounds(_imgWorldOrigin[0], _imgWorldOrigin[0] + _imgWorldDims[0],
-                                _imgWorldOrigin[1], _imgWorldOrigin[1] + _imgWorldDims[1], 0, 0);
+    if (_imgCameraPlane == PLANE_XY) {
+        // XY plane
+        camera->SetPosition(camPos[0], camPos[1], _imgCameraOffset + 1.);
+        camera->SetFocalPoint(camPos[0], camPos[1], _imgCameraOffset);
+        camera->SetViewUp(0, 1, 0);
+        // bottom
+        _cameraClipPlanes[0]->SetOrigin(0, _imgWorldOrigin[1], 0);
+        _cameraClipPlanes[0]->SetNormal(0, 1, 0);
+        // left
+        _cameraClipPlanes[1]->SetOrigin(_imgWorldOrigin[0], 0, 0);
+        _cameraClipPlanes[1]->SetNormal(1, 0, 0);
+        // top
+        _cameraClipPlanes[2]->SetOrigin(0, _imgWorldOrigin[1] + _imgWorldDims[1], 0);
+        _cameraClipPlanes[2]->SetNormal(0, -1, 0);
+        // right
+        _cameraClipPlanes[3]->SetOrigin(_imgWorldOrigin[0] + _imgWorldDims[0], 0, 0);
+        _cameraClipPlanes[3]->SetNormal(-1, 0, 0);
+        _cubeAxesActor2D->SetBounds(_imgWorldOrigin[0], _imgWorldOrigin[0] + _imgWorldDims[0],
+                                    _imgWorldOrigin[1], _imgWorldOrigin[1] + _imgWorldDims[1],
+                                    _imgCameraOffset, _imgCameraOffset);
+        _cubeAxesActor2D->XAxisVisibilityOn();
+        _cubeAxesActor2D->YAxisVisibilityOn();
+        _cubeAxesActor2D->ZAxisVisibilityOff();
+    } else if (_imgCameraPlane == PLANE_ZY) {
+        // ZY plane
+        camera->SetPosition(_imgCameraOffset - 1., camPos[1], camPos[0]);
+        camera->SetFocalPoint(_imgCameraOffset, camPos[1], camPos[0]);
+        camera->SetViewUp(0, 1, 0);
+        // bottom
+        _cameraClipPlanes[0]->SetOrigin(0, _imgWorldOrigin[1], 0);
+        _cameraClipPlanes[0]->SetNormal(0, 1, 0);
+        // left
+        _cameraClipPlanes[1]->SetOrigin(0, 0, _imgWorldOrigin[0]);
+        _cameraClipPlanes[1]->SetNormal(0, 0, 1);
+        // top
+        _cameraClipPlanes[2]->SetOrigin(0, _imgWorldOrigin[1] + _imgWorldDims[1], 0);
+        _cameraClipPlanes[2]->SetNormal(0, -1, 0);
+        // right
+        _cameraClipPlanes[3]->SetOrigin(0, 0, _imgWorldOrigin[0] + _imgWorldDims[0]);
+        _cameraClipPlanes[3]->SetNormal(0, 0, -1);
+        _cubeAxesActor2D->SetBounds(_imgCameraOffset, _imgCameraOffset, 
+                                    _imgWorldOrigin[1], _imgWorldOrigin[1] + _imgWorldDims[1],
+                                    _imgWorldOrigin[0], _imgWorldOrigin[0] + _imgWorldDims[0]);
+        _cubeAxesActor2D->XAxisVisibilityOff();
+        _cubeAxesActor2D->YAxisVisibilityOn();
+        _cubeAxesActor2D->ZAxisVisibilityOn();
+    } else {
+        // XZ plane
+        camera->SetPosition(camPos[0], _imgCameraOffset - 1., camPos[1]);
+        camera->SetFocalPoint(camPos[0], _imgCameraOffset, camPos[1]);
+        camera->SetViewUp(0, 0, 1);
+        // bottom
+        _cameraClipPlanes[0]->SetOrigin(0, 0, _imgWorldOrigin[1]);
+        _cameraClipPlanes[0]->SetNormal(0, 0, 1);
+        // left
+        _cameraClipPlanes[1]->SetOrigin(_imgWorldOrigin[0], 0, 0);
+        _cameraClipPlanes[1]->SetNormal(1, 0, 0);
+        // top
+        _cameraClipPlanes[2]->SetOrigin(0, 0, _imgWorldOrigin[1] + _imgWorldDims[1]);
+        _cameraClipPlanes[2]->SetNormal(0, 0, -1);
+        // right
+        _cameraClipPlanes[3]->SetOrigin(_imgWorldOrigin[0] + _imgWorldDims[0], 0, 0);
+        _cameraClipPlanes[3]->SetNormal(-1, 0, 0);
+        _cubeAxesActor2D->SetBounds(_imgWorldOrigin[0], _imgWorldOrigin[0] + _imgWorldDims[0],
+                                    _imgCameraOffset, _imgCameraOffset,
+                                    _imgWorldOrigin[1], _imgWorldOrigin[1] + _imgWorldDims[1]);
+        _cubeAxesActor2D->XAxisVisibilityOn();
+        _cubeAxesActor2D->YAxisVisibilityOff();
+        _cubeAxesActor2D->ZAxisVisibilityOn();
+    }
 
     // Compute screen world coordinates
@@ -7347,8 +7597,21 @@
     mat->Delete();
 
-    _screenWorldCoords[0] = x0;
-    _screenWorldCoords[1] = y0;
-    _screenWorldCoords[2] = x1 - x0;
-    _screenWorldCoords[3] = y1 - y0;
+    if (_imgCameraPlane == PLANE_XZ) {
+        _screenWorldCoords[0] = x0;
+        _screenWorldCoords[1] = z0;
+        _screenWorldCoords[2] = x1 - x0;
+        _screenWorldCoords[3] = z1 - z0;
+    } else if (_imgCameraPlane == PLANE_ZY) {
+        _screenWorldCoords[0] = z0;
+        _screenWorldCoords[1] = y0;
+        _screenWorldCoords[2] = z1 - z0;
+        _screenWorldCoords[3] = y1 - y0;
+    } else {
+        // XY
+        _screenWorldCoords[0] = x0;
+        _screenWorldCoords[1] = y0;
+        _screenWorldCoords[2] = x1 - x0;
+        _screenWorldCoords[3] = y1 - y0;
+    }
 }
 
@@ -7465,13 +7728,27 @@
             mergeBounds(bounds, bounds, itr->second->getProp()->GetBounds());
     }
-    for (int i = 0; i < 6; i++) {
-        if (i % 2 == 0) {
-            if (bounds[i] == DBL_MAX)
-                bounds[i] = 0;
-        } else {
-            if (bounds[i] == -DBL_MAX)
-                bounds[i] = 1;
+
+    for (int i = 0; i < 6; i += 2) {
+        if (bounds[i+1] < bounds[i]) {
+            bounds[i] = -0.5;
+            bounds[i+1] = 0.5;
         }
     }
+
+    int numDims = 0;
+    if (bounds[0] != bounds[1])
+        numDims++;
+    if (bounds[2] != bounds[3])
+        numDims++;
+    if (bounds[4] != bounds[5])
+        numDims++;
+
+    if (numDims == 0) {
+        bounds[0] -= .5;
+        bounds[1] += .5;
+        bounds[2] -= .5;
+        bounds[3] += .5;
+    }
+
     TRACE("Bounds: %g %g %g %g %g %g",
           bounds[0],
@@ -7564,4 +7841,16 @@
         collectVectorComponentRanges(_cumulativeVectorComponentRange[i], i,
                                      _cumulativeRangeOnlyVisible);
+    }
+
+    TRACE("Cumulative scalar range: %g, %g",
+          _cumulativeScalarRange[0],
+          _cumulativeScalarRange[1]);
+    TRACE("Cumulative vmag range: %g, %g",
+          _cumulativeVectorMagnitudeRange[0],
+          _cumulativeVectorMagnitudeRange[1]);
+    for (int i = 0; i < 3; i++) {
+        TRACE("Cumulative v[%d] range: %g, %g", i,
+              _cumulativeVectorComponentRange[i][0],
+              _cumulativeVectorComponentRange[i][1]);
     }
 }
@@ -7644,4 +7933,39 @@
         range[1] = 1;
  }
+
+/**
+ * \brief Determines if AABB lies in a principal axis plane
+ * and if so, returns the plane normal
+ */
+bool Renderer::is2D(const double bounds[6],
+                    Renderer::PrincipalPlane *plane,
+                    double *offset) const
+{
+    if (bounds[4] == bounds[5]) {
+        // Z = 0, XY plane
+        if (plane)
+            *plane = PLANE_XY;
+        if (offset)
+            *offset = bounds[4];
+        return true;
+    } else if (bounds[0] == bounds[1]) {
+        // X = 0, ZY plane
+        if (plane)
+            *plane = PLANE_ZY;
+        if (offset)
+            *offset = bounds[0];
+        return true;
+    } else if (bounds[2] == bounds[3]) {
+        // Y = 0, XZ plane
+        if (plane)
+            *plane = PLANE_XZ;
+        if (offset)
+            *offset = bounds[2];
+        return true;
+    }
+    *plane = PLANE_XY;
+    *offset = 0;
+    return false;
+}
 
 /**
@@ -7667,8 +7991,30 @@
     double bounds[6];
     collectBounds(bounds, false);
-    _imgWorldOrigin[0] = bounds[0];
-    _imgWorldOrigin[1] = bounds[2];
-    _imgWorldDims[0] = bounds[1] - bounds[0];
-    _imgWorldDims[1] = bounds[3] - bounds[2];
+    bool twod = is2D(bounds, &_imgCameraPlane, &_imgCameraOffset);
+    if (twod) {
+        _cameraMode = IMAGE;
+        if (_imgCameraPlane == PLANE_ZY) {
+            _imgWorldOrigin[0] = bounds[4];
+            _imgWorldOrigin[1] = bounds[2];
+            _imgWorldDims[0] = bounds[5] - bounds[4];
+            _imgWorldDims[1] = bounds[3] - bounds[2];
+        } else if (_imgCameraPlane == PLANE_XZ) {
+            _imgWorldOrigin[0] = bounds[0];
+            _imgWorldOrigin[1] = bounds[4];
+            _imgWorldDims[0] = bounds[1] - bounds[0];
+            _imgWorldDims[1] = bounds[5] - bounds[4];
+        } else {
+            _imgWorldOrigin[0] = bounds[0];
+            _imgWorldOrigin[1] = bounds[2];
+            _imgWorldDims[0] = bounds[1] - bounds[0];
+            _imgWorldDims[1] = bounds[3] - bounds[2];
+        }
+    } else {
+        _imgWorldOrigin[0] = bounds[0];
+        _imgWorldOrigin[1] = bounds[2];
+        _imgWorldDims[0] = bounds[1] - bounds[0];
+        _imgWorldDims[1] = bounds[3] - bounds[2];
+    }
+
     _cameraPan[0] = 0;
     _cameraPan[1] = 0;
@@ -7697,4 +8043,5 @@
         ERROR("Unknown camera mode");
     }
+
 #ifdef WANT_TRACE
     printCameraInfo(_renderer->GetActiveCamera());
@@ -7707,7 +8054,8 @@
 void Renderer::printCameraInfo(vtkCamera *camera)
 {
-    TRACE("Parallel Scale: %g, View angle: %g, Cam pos: %g %g %g, focal pt: %g %g %g, view up: %g %g %g, Clipping range: %g %g",
+    TRACE("pscale: %g, angle: %g, d: %g pos: %g %g %g, fpt: %g %g %g, vup: %g %g %g, clip: %g %g",
           camera->GetParallelScale(),
           camera->GetViewAngle(),
+          camera->GetDistance(),
           camera->GetPosition()[0],
           camera->GetPosition()[1],
@@ -8096,17 +8444,17 @@
  * Note: no interpolation is performed on data
  */
-double Renderer::getDataValueAtPixel(const DataSetId& id, int x, int y)
+bool Renderer::getScalarValueAtPixel(const DataSetId& id, int x, int y, double *value)
 {
     vtkSmartPointer<vtkCoordinate> coord = vtkSmartPointer<vtkCoordinate>::New();
     coord->SetCoordinateSystemToDisplay();
-    coord->SetValue(x, y, 0);
+    coord->SetValue(x, _windowHeight - y, 0);
     double *worldCoords = coord->GetComputedWorldValue(_renderer);
 
-    TRACE("Pixel coords: %d, %d\nWorld coords: %.12e, %.12e, %12e", x, y,
+    TRACE("Pixel coords: %d, %d\nWorld coords: %g, %g, %g", x, y,
           worldCoords[0], 
           worldCoords[1], 
           worldCoords[2]);
 
-    return getDataValue(id, worldCoords[0], worldCoords[1], worldCoords[2]);
+    return getScalarValue(id, worldCoords[0], worldCoords[1], worldCoords[2], value);
 }
 
@@ -8116,11 +8464,44 @@
  * Note: no interpolation is performed on data
  */
-double Renderer::getDataValue(const DataSetId& id, double x, double y, double z)
+bool Renderer::getScalarValue(const DataSetId& id, double x, double y, double z, double *value)
 {
     DataSet *ds = getDataSet(id);
     if (ds == NULL)
-        return 0;
-    vtkDataSet *vtkds = ds->getVtkDataSet(); 
-    vtkIdType pt = vtkds->FindPoint(x, y, z);
-    return vtkds->GetPointData()->GetScalars()->GetComponent(pt, 0);
-}
+        return false;
+
+    return ds->getScalarValue(x, y, z, value);
+}
+
+/**
+ * \brief Get nearest data value given display coordinates x,y
+ *
+ * Note: no interpolation is performed on data
+ */
+bool Renderer::getVectorValueAtPixel(const DataSetId& id, int x, int y, double vector[3])
+{
+    vtkSmartPointer<vtkCoordinate> coord = vtkSmartPointer<vtkCoordinate>::New();
+    coord->SetCoordinateSystemToDisplay();
+    coord->SetValue(x, _windowHeight - y, 0);
+    double *worldCoords = coord->GetComputedWorldValue(_renderer);
+
+    TRACE("Pixel coords: %d, %d\nWorld coords: %g, %g, %g", x, y,
+          worldCoords[0], 
+          worldCoords[1], 
+          worldCoords[2]);
+
+    return getVectorValue(id, worldCoords[0], worldCoords[1], worldCoords[2], vector);
+}
+
+/**
+ * \brief Get nearest data value given world coordinates x,y,z
+ *
+ * Note: no interpolation is performed on data
+ */
+bool Renderer::getVectorValue(const DataSetId& id, double x, double y, double z, double vector[3])
+{
+    DataSet *ds = getDataSet(id);
+    if (ds == NULL)
+        return false;
+
+    return ds->getVectorValue(x, y, z, vector);
+}
